Index: pc98/pc98/isa_dma.c
===================================================================
RCS file: /home/ncvs/src/sys/pc98/pc98/isa_dma.c,v
retrieving revision 1.10
diff -u -r1.10 isa_dma.c
--- pc98/pc98/isa_dma.c	2001/06/30 05:29:09	1.10
+++ pc98/pc98/isa_dma.c	2001/07/04 02:54:16
@@ -249,6 +249,8 @@
 	int waport;
 	caddr_t newaddr;
 
+	GIANT_REQUIRED;
+
 #ifdef DIAGNOSTIC
 	if (chan & ~VALID_DMA_MASK)
 		panic("isa_dmastart: channel out of range");
@@ -287,12 +289,7 @@
 	}
 
 	/* translate to physical */
-	mtx_lock(&vm_mtx);	/*
-				 * XXX: need to hold for longer period to
-				 * ensure that mappings don't change
-				 */
 	phys = pmap_extract(pmap_kernel(), (vm_offset_t)addr);
-	mtx_unlock(&vm_mtx);
 
 	if (flags & ISADMA_RAW) {
 	    dma_auto_mode |= (1 << chan);
@@ -438,11 +435,11 @@
 	vm_offset_t phys, priorpage = 0, endva;
 	u_int dma_pgmsk = (chan & 4) ?  ~(128*1024-1) : ~(64*1024-1);
 
+	GIANT_REQUIRED;
+
 	endva = (vm_offset_t)round_page((vm_offset_t)va + length);
 	for (; va < (caddr_t) endva ; va += PAGE_SIZE) {
-		mtx_lock(&vm_mtx);
 		phys = trunc_page(pmap_extract(pmap_kernel(), (vm_offset_t)va));
-		mtx_unlock(&vm_mtx);
 #ifdef EPSON_BOUNCEDMA
 #define ISARAM_END	0xf00000
 #else
Index: sys/mutex.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/mutex.h,v
retrieving revision 1.31
diff -u -r1.31 mutex.h
--- sys/mutex.h	2001/05/04 17:15:16	1.31
+++ sys/mutex.h	2001/07/04 02:54:16
@@ -372,8 +372,34 @@
 #define	mtx_assert(m, what)						\
 	_mtx_assert((m), (what), __FILE__, __LINE__)
 
+/*
+ *  GIANT_REQUIRED;	- place at the beginning of a procedure 
+ *
+ *
+ */
+
+#define GIANT_REQUIRED							\
+	do {								\
+		KASSERT(curproc->p_giant_optional == 0, ("Giant not optional at %s: %d", __FILE__, __LINE__));						\
+		mtx_assert(&Giant, MA_OWNED);				\
+	} while(0)
+#define START_GIANT_DEPRECIATED(sysctlvar)				\
+	int __gotgiant = (curproc->p_giant_optional == 0 && sysctlvar) ? \
+		(mtx_lock(&Giant), 1) : 0
+#define END_GIANT_DEPRECIATED						\
+	if (__gotgiant) mtx_unlock(&Giant)
+#define START_GIANT_OPTIONAL						\
+	++curproc->p_giant_optional
+#define END_GIANT_OPTIONAL						\
+	--curproc->p_giant_optional
+
 #else	/* INVARIANTS */
 #define mtx_assert(m, what)
+#define GIANT_REQUIRED
+#define START_GIANT_DEPRECIATED(sysctl)
+#define END_GIANT_DEPRECIATED
+#define START_GIANT_OPTIONAL
+#define END_GIANT_OPTIONAL
 #endif	/* INVARIANTS */
 
 #endif	/* _KERNEL */
Index: sys/proc.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/proc.h,v
retrieving revision 1.169
diff -u -r1.169 proc.h
--- sys/proc.h	2001/06/30 03:35:22	1.169
+++ sys/proc.h	2001/07/04 02:54:16
@@ -276,6 +276,7 @@
 	struct	pasleep p_asleep;	/* (k) Used by asleep()/await(). */
 	void	*p_emuldata;	/* (c) Emulator state data. */
 	struct trapframe *p_frame; /* (k) */
+	int	p_giant_optional;	/* (i) Giant Lock Sanity */
 };
 
 #define	p_session	p_pgrp->pg_session
Index: ufs/ufs/ufs_readwrite.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_readwrite.c,v
retrieving revision 1.80
diff -u -r1.80 ufs_readwrite.c
--- ufs/ufs/ufs_readwrite.c	2001/05/24 07:22:27	1.80
+++ ufs/ufs/ufs_readwrite.c	2001/07/04 02:54:16
@@ -80,6 +80,8 @@
 	int ioflag;
 	vm_object_t object;
 
+	GIANT_REQUIRED;
+
 	vp = ap->a_vp;
 	seqcount = ap->a_ioflag >> 16;
 	ip = VTOI(vp);
@@ -115,9 +117,7 @@
 	}
 
 	if (object) {
-		mtx_lock(&vm_mtx);
 		vm_object_reference(object);
-		mtx_unlock(&vm_mtx);
 	}
 
 #ifdef ENABLE_VFS_IOOPT
@@ -151,9 +151,7 @@
 					ip->i_flag |= IN_ACCESS;
 
 				if (object) {
-					mtx_lock(&vm_mtx);
 					vm_object_vndeallocate(object);
-					mtx_unlock(&vm_mtx);
 				}
 				return error;
 			}
@@ -199,9 +197,7 @@
 					    MNT_NOATIME) == 0)
 						ip->i_flag |= IN_ACCESS;
 					if (object) {
-						mtx_lock(&vm_mtx);
 						vm_object_vndeallocate(object);
-						mtx_unlock(&vm_mtx);
 					}
 					return error;
 				}
@@ -374,9 +370,7 @@
 	}
 
 	if (object) {
-		mtx_lock(&vm_mtx);
 		vm_object_vndeallocate(object);
-		mtx_unlock(&vm_mtx);
 	}
 	if ((error == 0 || uio->uio_resid != orig_resid) &&
 	    (vp->v_mount->mnt_flag & MNT_NOATIME) == 0)
@@ -408,6 +402,8 @@
 	int blkoffset, error, extended, flags, ioflag, resid, size, xfersize;
 	vm_object_t object;
 
+	GIANT_REQUIRED;
+
 	extended = 0;
 	seqcount = ap->a_ioflag >> 16;
 	ioflag = ap->a_ioflag;
@@ -417,9 +413,7 @@
 
 	object = vp->v_object;
 	if (object) {
-		mtx_lock(&vm_mtx);
 		vm_object_reference(object);
-		mtx_unlock(&vm_mtx);
 	}
 
 #ifdef DIAGNOSTIC
@@ -433,9 +427,7 @@
 			uio->uio_offset = ip->i_size;
 		if ((ip->i_flags & APPEND) && uio->uio_offset != ip->i_size) {
 			if (object) {
-				mtx_lock(&vm_mtx);
 				vm_object_vndeallocate(object);
-				mtx_unlock(&vm_mtx);
 			}
 			return (EPERM);
 		}
@@ -456,9 +448,7 @@
 	if (uio->uio_offset < 0 ||
 	    (u_int64_t)uio->uio_offset + uio->uio_resid > fs->fs_maxfilesize) {
 		if (object) {
-			mtx_lock(&vm_mtx);
 			vm_object_vndeallocate(object);
-			mtx_unlock(&vm_mtx);
 		}
 		return (EFBIG);
 	}
@@ -474,9 +464,7 @@
 		psignal(p, SIGXFSZ);
 		PROC_UNLOCK(p);
 		if (object) {
-			mtx_lock(&vm_mtx);
 			vm_object_vndeallocate(object);
-			mtx_unlock(&vm_mtx);
 		}
 		return (EFBIG);
 	}
@@ -488,11 +476,9 @@
 		flags = B_SYNC;
 
 	if (object && (object->flags & OBJ_OPT)) {
-		mtx_lock(&vm_mtx);
 		vm_freeze_copyopts(object,
 			OFF_TO_IDX(uio->uio_offset),
 			OFF_TO_IDX(uio->uio_offset + uio->uio_resid + PAGE_MASK));
-		mtx_unlock(&vm_mtx);
 	}
 
 	for (error = 0; uio->uio_resid > 0;) {
@@ -595,9 +581,7 @@
 		error = UFS_UPDATE(vp, 1);
 
 	if (object) {
-		mtx_lock(&vm_mtx);
 		vm_object_vndeallocate(object);
-		mtx_unlock(&vm_mtx);
 	}
 
 	return (error);
@@ -627,6 +611,7 @@
 	int rtval;
 	int pagesperblock;
 
+	GIANT_REQUIRED;
 
 	pcount = round_page(ap->a_count) / PAGE_SIZE;
 	mreq = ap->a_m[ap->a_reqpage];
@@ -668,16 +653,9 @@
 	reqlblkno = foff / bsize;
 	poff = (foff % bsize) / PAGE_SIZE;
 
-	mtx_unlock(&vm_mtx);
-	mtx_lock(&Giant);
-
 	dp = VTOI(vp)->i_devvp;
 	if (ufs_bmaparray(vp, reqlblkno, &reqblkno, &bforwards, &bbackwards)
 	    || (reqblkno == -1)) {
-
-		mtx_unlock(&Giant);
-		mtx_lock(&vm_mtx);
-
 		for(i = 0; i < pcount; i++) {
 			if (i != ap->a_reqpage)
 				vm_page_free(ap->a_m[i]);
@@ -692,9 +670,6 @@
 			return VM_PAGER_ERROR;
 		}
 	}
-
-	mtx_unlock(&Giant);
-	mtx_lock(&vm_mtx);
 
 	physoffset = (off_t)reqblkno * DEV_BSIZE + poff * PAGE_SIZE;
 	pagesperblock = bsize / PAGE_SIZE;
Index: vm/default_pager.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/default_pager.c,v
retrieving revision 1.27
diff -u -r1.27 default_pager.c
--- vm/default_pager.c	2001/05/19 01:28:08	1.27
+++ vm/default_pager.c	2001/07/04 02:54:16
@@ -42,6 +42,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/lock.h>
+#include <sys/proc.h>
 #include <sys/mutex.h>
 
 #include <vm/vm.h>
Index: vm/device_pager.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/device_pager.c,v
retrieving revision 1.51
diff -u -r1.51 device_pager.c
--- vm/device_pager.c	2001/05/23 22:27:52	1.51
+++ vm/device_pager.c	2001/07/04 02:54:16
@@ -43,6 +43,7 @@
 #include <sys/systm.h>
 #include <sys/conf.h>
 #include <sys/lock.h>
+#include <sys/proc.h>
 #include <sys/mutex.h>
 #include <sys/mman.h>
 #include <sys/sx.h>
Index: vm/phys_pager.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/phys_pager.c,v
retrieving revision 1.9
diff -u -r1.9 phys_pager.c
--- vm/phys_pager.c	2001/05/23 19:52:23	1.9
+++ vm/phys_pager.c	2001/07/04 02:54:16
@@ -31,6 +31,7 @@
 #include <sys/conf.h>
 #include <sys/kernel.h>
 #include <sys/lock.h>
+#include <sys/proc.h>
 #include <sys/mutex.h>
 #include <sys/mman.h>
 #include <sys/sysctl.h>
@@ -62,6 +63,8 @@
 {
 	vm_object_t object;
 
+	GIANT_REQUIRED;
+
 	/*
 	 * Offset should be page aligned.
 	 */
@@ -76,7 +79,7 @@
 		 */
 		while (phys_pager_alloc_lock) {
 			phys_pager_alloc_lock = -1;
-			msleep(&phys_pager_alloc_lock, &vm_mtx, PVM, "swpalc", 0);
+			tsleep(&phys_pager_alloc_lock, PVM, "swpalc", 0);
 		}
 		phys_pager_alloc_lock = 1;
 
Index: vm/swap_pager.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/swap_pager.c,v
retrieving revision 1.159
diff -u -r1.159 swap_pager.c
--- vm/swap_pager.c	2001/06/22 21:12:19	1.159
+++ vm/swap_pager.c	2001/07/04 02:54:17
@@ -80,6 +80,7 @@
 #include <sys/sysctl.h>
 #include <sys/blist.h>
 #include <sys/lock.h>
+#include <sys/sx.h>
 #include <sys/vmmeter.h>
 
 #ifndef MAX_PAGEOUT_CLUSTER
@@ -118,12 +119,12 @@
 static int nsw_wcount_async;	/* limit write buffers / asynchronous	*/
 static int nsw_wcount_async_max;/* assigned maximum			*/
 static int nsw_cluster_max;	/* maximum VOP I/O allowed		*/
-static int sw_alloc_interlock;	/* swap pager allocation interlock	*/
 
 struct blist *swapblist;
 static struct swblock **swhash;
 static int swhash_mask;
 static int swap_async_max = 4;	/* maximum in-progress async I/O's	*/
+static struct sx sw_alloc_sx;
 
 /* from vm_swap.c */
 extern struct vnode *swapdev_vp;
@@ -232,8 +233,8 @@
 static __inline void
 swp_sizecheck()
 {
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (vm_swap_size < nswap_lowat) {
 		if (swap_pager_almost_full == 0) {
 			printf("swap_pager: out of swap space\n");
@@ -383,7 +384,8 @@
 {
 	vm_object_t object;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	if (handle) {
 		/*
 		 * Reference existing named region or allocate new one.  There
@@ -391,13 +393,7 @@
 		 * as called from vm_page_remove() in regards to the lookup
 		 * of the handle.
 		 */
-
-		while (sw_alloc_interlock) {
-			sw_alloc_interlock = -1;
-			msleep(&sw_alloc_interlock, &vm_mtx, PVM, "swpalc", 0);
-		}
-		sw_alloc_interlock = 1;
-
+		sx_xlock(&sw_alloc_sx);
 		object = vm_pager_object_lookup(NOBJLIST(handle), handle);
 
 		if (object != NULL) {
@@ -409,10 +405,7 @@
 
 			swp_pager_meta_build(object, 0, SWAPBLK_NONE);
 		}
-
-		if (sw_alloc_interlock == -1)
-			wakeup(&sw_alloc_interlock);
-		sw_alloc_interlock = 0;
+		sx_xunlock(&sw_alloc_sx);
 	} else {
 		object = vm_object_allocate(OBJT_DEFAULT,
 			OFF_TO_IDX(offset + PAGE_MASK + size));
@@ -441,13 +434,13 @@
 	vm_object_t object;
 {
 	int s;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	/*
 	 * Remove from list right away so lookups will fail if we block for
 	 * pageout completion.
 	 */
-
 	mtx_lock(&sw_alloc_mtx);
 	if (object->handle == NULL) {
 		TAILQ_REMOVE(&swap_pager_un_object_list, object, pager_object_list);
@@ -488,7 +481,6 @@
  *
  *	This routine may not block
  *	This routine must be called at splvm().
- *	vm_mtx should be held
  */
 
 static __inline daddr_t
@@ -496,8 +488,9 @@
 	int npages;
 {
 	daddr_t blk;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if ((blk = blist_alloc(swapblist, npages)) == SWAPBLK_NONE) {
 		if (swap_pager_full != 2) {
 			printf("swap_pager_getswapspace: failed\n");
@@ -526,7 +519,6 @@
  *
  *	This routine may not block
  *	This routine must be called at splvm().
- *	vm_mtx should be held
  */
 
 static __inline void
@@ -534,8 +526,8 @@
 	daddr_t blk;
 	int npages;
 {
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	blist_free(swapblist, blk, npages);
 	vm_swap_size += npages;
 	/* per-swap area stats */
@@ -566,9 +558,8 @@
 	vm_size_t size;
 {
 	int s = splvm();
-	
-	mtx_assert(&vm_mtx, MA_OWNED);
 
+	GIANT_REQUIRED;
 	swp_pager_meta_free(object, start, size);
 	splx(s);
 }
@@ -650,11 +641,10 @@
 {
 	vm_pindex_t i;
 	int s;
-
-	s = splvm();
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 
+	s = splvm();
 	/*
 	 * If destroysource is set, we remove the source object from the 
 	 * swap_pager internal queue now. 
@@ -870,9 +860,9 @@
 	int s;
 	char *data;
 	struct buf *nbp = NULL;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&Giant, MA_OWNED);
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
 	/* XXX: KASSERT instead ? */
 	if (bp->bio_bcount & PAGE_MASK) {
 		biofinish(bp, NULL, EINVAL);
@@ -903,9 +893,7 @@
 		 * FREE PAGE(s) - destroy underlying swap that is no longer
 		 *		  needed.
 		 */
-		mtx_lock(&vm_mtx);
 		swp_pager_meta_free(object, start, count);
-		mtx_unlock(&vm_mtx);
 		splx(s);
 		bp->bio_resid = 0;
 		biodone(bp);
@@ -915,8 +903,6 @@
 	/*
 	 * Execute read or write
 	 */
-
-	mtx_lock(&vm_mtx);
 	while (count > 0) {
 		daddr_t blk;
 
@@ -959,9 +945,7 @@
 				cnt.v_swappgsout += btoc(nbp->b_bcount);
 				nbp->b_dirtyend = nbp->b_bcount;
 			}
-			mtx_unlock(&vm_mtx);
 			flushchainbuf(nbp);
-			mtx_lock(&vm_mtx);
 			s = splvm();
 			nbp = NULL;
 		}
@@ -981,9 +965,7 @@
 			bp->bio_resid -= PAGE_SIZE;
 		} else {
 			if (nbp == NULL) {
-				mtx_unlock(&vm_mtx);
 				nbp = getchainbuf(bp, swapdev_vp, B_ASYNC);
-				mtx_lock(&vm_mtx);
 				nbp->b_blkno = blk;
 				nbp->b_bcount = 0;
 				nbp->b_data = data;
@@ -1010,11 +992,9 @@
 			cnt.v_swappgsout += btoc(nbp->b_bcount);
 			nbp->b_dirtyend = nbp->b_bcount;
 		}
-		mtx_unlock(&vm_mtx);
 		flushchainbuf(nbp);
 		/* nbp = NULL; */
-	} else
-		mtx_unlock(&vm_mtx);
+	}
 	/*
 	 * Wait for completion.
 	 */
@@ -1056,8 +1036,9 @@
 	daddr_t blk;
 	vm_offset_t kva;
 	vm_pindex_t lastpindex;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&Giant, MA_OWNED);
 	mreq = m[reqpage];
 
 	if (mreq->object != object) {
@@ -1185,10 +1166,8 @@
 	 *
 	 * NOTE: b_blkno is destroyed by the call to VOP_STRATEGY
 	 */
-	mtx_unlock(&vm_mtx);
 	BUF_KERNPROC(bp);
 	BUF_STRATEGY(bp);
-	mtx_lock(&vm_mtx);
 
 	/*
 	 * wait for the page we want to complete.  PG_SWAPINPROG is always
@@ -1201,7 +1180,7 @@
 	while ((mreq->flags & PG_SWAPINPROG) != 0) {
 		vm_page_flag_set(mreq, PG_WANTED | PG_REFERENCED);
 		cnt.v_intrans++;
-		if (msleep(mreq, &vm_mtx, PSWP, "swread", hz*20)) {
+		if (tsleep(mreq, PSWP, "swread", hz*20)) {
 			printf(
 			    "swap_pager: indefinite wait buffer: device:"
 				" %s, blkno: %ld, size: %ld\n",
@@ -1267,7 +1246,7 @@
 	int i;
 	int n = 0;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	if (count && m[0]->object != object) {
 		panic("swap_pager_getpages: object mismatch %p/%p", 
 		    object, 
@@ -1432,7 +1411,6 @@
 		swapdev_vp->v_numoutput++;
 
 		splx(s);
-		mtx_unlock(&vm_mtx);
 
 		/*
 		 * asynchronous
@@ -1444,7 +1422,6 @@
 			bp->b_iodone = swp_pager_async_iodone;
 			BUF_KERNPROC(bp);
 			BUF_STRATEGY(bp);
-			mtx_lock(&vm_mtx);
 
 			for (j = 0; j < n; ++j)
 				rtvals[i+j] = VM_PAGER_PEND;
@@ -1482,8 +1459,6 @@
 		 */
 
 		swp_pager_async_iodone(bp);
-		mtx_lock(&vm_mtx);
-
 		splx(s);
 	}
 }
@@ -1533,7 +1508,8 @@
 	int i;
 	vm_object_t object = NULL;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
+	GIANT_REQUIRED;
+
 	bp->b_flags |= B_DONE;
 
 	/*
@@ -1562,7 +1538,6 @@
 	/*
 	 * remove the mapping for kernel virtual
 	 */
-	mtx_lock(&vm_mtx);
 	pmap_qremove((vm_offset_t)bp->b_data, bp->b_npages);
 
 	/*
@@ -1697,7 +1672,6 @@
 	if (object)
 		vm_object_pip_wakeupn(object, bp->b_npages);
 
-	mtx_unlock(&vm_mtx);
 	/*
 	 * release the physical I/O buffer
 	 */
@@ -1771,8 +1745,6 @@
  *
  *	This routine must be called at splvm(), except when used to convert
  *	an OBJT_DEFAULT object into an OBJT_SWAP object.
- *
- *	Requires vm_mtx.
  */
 
 static void
@@ -1784,7 +1756,7 @@
 	struct swblock *swap;
 	struct swblock **pswap;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * Convert default object to swap object if necessary
 	 */
@@ -1871,15 +1843,13 @@
  *	out.  This routine does *NOT* operate on swap metadata associated
  *	with resident pages.
  *
- * 	vm_mtx must be held
  *	This routine must be called at splvm()
  */
 
 static void
 swp_pager_meta_free(vm_object_t object, vm_pindex_t index, daddr_t count)
 {
-
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 
 	if (object->type != OBJT_SWAP)
 		return;
@@ -1920,7 +1890,6 @@
  *	an object.
  *
  *	This routine must be called at splvm()
- *	Requires vm_mtx.
  */
 
 static void
@@ -1928,7 +1897,7 @@
 {
 	daddr_t index = 0;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	
 	if (object->type != OBJT_SWAP)
 		return;
@@ -1978,7 +1947,6 @@
  *	busy page.
  *
  *	This routine must be called at splvm().
- *	Requires vm_mtx.
  *
  *	SWM_FREE	remove and free swap block from metadata
  *	SWM_POP		remove from meta data but do not free.. pop it out
@@ -1994,7 +1962,7 @@
 	struct swblock *swap;
 	daddr_t r1;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * The meta data only exists of the object is OBJT_SWAP 
 	 * and even then might not be allocated yet.
@@ -2082,8 +2050,6 @@
  *	Obtain a physical buffer and chain it to its parent buffer.  When
  *	I/O completes, the parent buffer will be B_SIGNAL'd.  Errors are
  *	automatically propagated to the parent
- *
- *	vm_mtx can't be held
  */
 
 struct buf *
@@ -2092,8 +2058,7 @@
 	struct buf *nbp;
 	u_int *count;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	nbp = getpbuf(NULL);
 	count = (u_int *)&(bp->bio_caller1);
 
@@ -2120,9 +2085,7 @@
 void
 flushchainbuf(struct buf *nbp)
 {
-	
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	if (nbp->b_bcount) {
 		nbp->b_bufsize = nbp->b_bcount;
 		if (nbp->b_iocmd == BIO_WRITE)
@@ -2140,8 +2103,7 @@
  	int s;
 	u_int *count;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	count = (u_int *)&(bp->bio_caller1);
 	s = splbio();
 	while (*count > limit) {
Index: vm/vm.h
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm.h,v
retrieving revision 1.17
diff -u -r1.17 vm.h
--- vm/vm.h	2001/05/19 01:28:08	1.17
+++ vm/vm.h	2001/07/04 02:54:17
@@ -95,10 +95,6 @@
 struct vm_object;
 typedef struct vm_object *vm_object_t;
 
-#ifdef _KERNEL
-extern struct mtx vm_mtx;
-#endif
-
 #ifndef _KERNEL
 /*
  * This is defined in <sys/types.h> for the kernel so that non-vm kernel
Index: vm/vm_fault.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_fault.c,v
retrieving revision 1.121
diff -u -r1.121 vm_fault.c
--- vm/vm_fault.c	2001/05/23 22:09:18	1.121
+++ vm/vm_fault.c	2001/07/04 02:54:17
@@ -136,9 +136,7 @@
 static void
 _unlock_things(struct faultstate *fs, int dealloc)
 {
-
-    	mtx_assert(&vm_mtx, MA_OWNED);
-    	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	vm_object_pip_wakeup(fs->object);
 	if (fs->object != fs->first_object) {
 		vm_page_free(fs->first_m);
@@ -150,13 +148,8 @@
 	}
 	unlock_map(fs);	
 	if (fs->vp != NULL) { 
-		struct vnode	*vp;
-
-		vp = fs->vp;
+		vput(fs->vp);
 		fs->vp = NULL;
-		mtx_unlock(&vm_mtx);
-		vput(vp);
-		mtx_lock(&vm_mtx);
 	}
 }
 
@@ -189,37 +182,20 @@
  *
  *
  *	The map in question must be referenced, and remains so.
- *	Caller may hold no locks except the vm_mtx which will be
- *	locked if needed.
+ *	Caller may hold no locks.
  */
 static int vm_fault1 __P((vm_map_t, vm_offset_t, vm_prot_t, int));
 
-static int vm_faults_no_vm_mtx;
-SYSCTL_INT(_vm, OID_AUTO, vm_faults_no_vm_mtx, CTLFLAG_RW,
-	   &vm_faults_no_vm_mtx, 0, "");
-
-static int vm_faults_no_giant;
-SYSCTL_INT(_vm, OID_AUTO, vm_faults_no_giant, CTLFLAG_RW,
-	   &vm_faults_no_giant, 0, "");
-
 int
 vm_fault(vm_map_t map, vm_offset_t vaddr, vm_prot_t fault_type,
 	 int fault_flags)
 {
-	int hadvmlock, hadgiant, ret;
+	int ret;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	hadgiant = mtx_owned(&Giant);
 	mtx_lock(&Giant);
-	if (!hadvmlock) {
-		mtx_lock(&vm_mtx);
-		vm_faults_no_vm_mtx++;
-		if (hadgiant == 0)
-			vm_faults_no_giant++;
-	}
+	/* GIANT_REQUIRED */
+
 	ret = vm_fault1(map, vaddr, fault_type, fault_flags);
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	mtx_unlock(&Giant);
 	return (ret);
 }
@@ -237,8 +213,9 @@
 	int hardfault;
 	int faultcount;
 	struct faultstate fs;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	cnt.v_vm_faults++;
 	hardfault = 0;
 
@@ -296,9 +273,7 @@
 	vm_object_reference(fs.first_object);
 	vm_object_pip_add(fs.first_object, 1);
 
-	mtx_unlock(&vm_mtx);
 	fs.vp = vnode_pager_lock(fs.first_object);
-	mtx_lock(&vm_mtx);
 	if ((fault_type & VM_PROT_WRITE) &&
 		(fs.first_object->type == OBJT_VNODE)) {
 		vm_freeze_copyopts(fs.first_object,
@@ -770,9 +745,7 @@
 		 */
 
 		if (fs.vp != NULL) {
-			mtx_unlock(&vm_mtx);
 			vput(fs.vp);
-			mtx_lock(&vm_mtx);
 			fs.vp = NULL;
 		}
 		
@@ -988,8 +961,9 @@
 	register vm_offset_t va;
 	register pmap_t pmap;
 	int rv;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	pmap = vm_map_pmap(map);
 
 	/*
@@ -1164,7 +1138,6 @@
  *  number of pages in marray
  *
  * This routine can't block.
- * vm_mtx must be held.
  */
 static int
 vm_fault_additional_pages(m, rbehind, rahead, marray, reqpage)
@@ -1180,7 +1153,7 @@
 	vm_page_t rtm;
 	int cbehind, cahead;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 
 	object = m->object;
 	pindex = m->pindex;
Index: vm/vm_glue.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_glue.c,v
retrieving revision 1.115
diff -u -r1.115 vm_glue.c
--- vm/vm_glue.c	2001/06/20 00:48:20	1.115
+++ vm/vm_glue.c	2001/07/04 02:54:17
@@ -145,6 +145,8 @@
 	vm_map_t map;
 	vm_map_entry_t save_hint;
 
+	GIANT_REQUIRED;
+
 	KASSERT((rw & (~VM_PROT_ALL)) == 0,
 	    ("illegal ``rw'' argument to useracc (%x)\n", rw));
 	prot = rw;
@@ -161,7 +163,6 @@
 	    || (vm_offset_t) addr + len < (vm_offset_t) addr) {
 		return (FALSE);
 	}
-	mtx_lock(&vm_mtx);
 	map = &curproc->p_vmspace->vm_map;
 	vm_map_lock_read(map);
 	/*
@@ -173,7 +174,6 @@
 	    trunc_page((vm_offset_t)addr), round_page((vm_offset_t)addr + len), prot);
 	map->hint = save_hint;
 	vm_map_unlock_read(map);
-	mtx_unlock(&vm_mtx);
 	
 	return (rv == TRUE);
 }
@@ -183,12 +183,10 @@
 	caddr_t addr;
 	u_int len;
 {
-
-	mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 	vm_map_pageable(&curproc->p_vmspace->vm_map,
 	    trunc_page((vm_offset_t)addr),
 	    round_page((vm_offset_t)addr + len), FALSE);
-	mtx_unlock(&vm_mtx);
 }
 
 void
@@ -196,12 +194,10 @@
 	caddr_t addr;
 	u_int len;
 {
-
-	mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 	vm_map_pageable(&curproc->p_vmspace->vm_map,
 	    trunc_page((vm_offset_t)addr),
 	    round_page((vm_offset_t)addr + len), TRUE);
-	mtx_unlock(&vm_mtx);
 }
 
 /*
@@ -211,8 +207,6 @@
  * machine-dependent layer to fill those in and make the new process
  * ready to run.  The new process is set up so that it returns directly
  * to user mode to avoid stack copying and relocation problems.
- *
- * Called without vm_mtx.
  */
 void
 vm_fork(p1, p2, flags)
@@ -221,7 +215,8 @@
 {
 	register struct user *up;
 
-	mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
+
 	if ((flags & RFPROC) == 0) {
 		/*
 		 * Divorce the memory, if it is shared, essentially
@@ -234,7 +229,6 @@
 			}
 		}
 		cpu_fork(p1, p2, flags);
-		mtx_unlock(&vm_mtx);
 		return;
 	}
 
@@ -289,7 +283,6 @@
 	 * and make the child ready to run.
 	 */
 	cpu_fork(p1, p2, flags);
-	mtx_unlock(&vm_mtx);
 }
 
 /*
@@ -329,18 +322,16 @@
 faultin(p)
 	struct proc *p;
 {
+	GIANT_REQUIRED;
 
 	PROC_LOCK_ASSERT(p, MA_OWNED);
 	mtx_lock_spin(&sched_lock);
 	if ((p->p_sflag & PS_INMEM) == 0) {
-
 		++p->p_lock;
 		mtx_unlock_spin(&sched_lock);
 		PROC_UNLOCK(p);
 
-		mtx_lock(&vm_mtx);
 		pmap_swapin_proc(p);
-		mtx_unlock(&vm_mtx);
 
 		PROC_LOCK(p);
 		mtx_lock_spin(&sched_lock);
@@ -374,15 +365,13 @@
 	int ppri;
 
 	mtx_assert(&Giant, MA_OWNED | MA_NOTRECURSED);
+	/* GIANT_REQUIRED */
 
 loop:
-	mtx_lock(&vm_mtx);
 	if (vm_page_count_min()) {
 		VM_WAIT;
-		mtx_unlock(&vm_mtx);
 		goto loop;
 	}
-	mtx_unlock(&vm_mtx);
 
 	pp = NULL;
 	ppri = INT_MIN;
@@ -458,9 +447,6 @@
  * If any procs have been sleeping/stopped for at least maxslp seconds,
  * they are swapped.  Else, we swap the longest-sleeping or stopped process,
  * if any, otherwise the longest-resident process.
- *
- * Can block
- * must be called with vm_mtx
  */
 void
 swapout_procs(action)
@@ -470,9 +456,9 @@
 	struct proc *outp, *outp2;
 	int outpri, outpri2;
 	int didswap = 0;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
-	mtx_unlock(&vm_mtx);
 	outp = outp2 = NULL;
 	outpri = outpri2 = INT_MIN;
 retry:
@@ -480,12 +466,10 @@
 	LIST_FOREACH(p, &allproc, p_list) {
 		struct vmspace *vm;
 		
-		mtx_lock(&vm_mtx);
 		PROC_LOCK(p);
 		if (p->p_lock != 0 ||
 		    (p->p_flag & (P_TRACED|P_SYSTEM|P_WEXIT)) != 0) {
 			PROC_UNLOCK(p);
-			mtx_unlock(&vm_mtx);
 			continue;
 		}
 		/*
@@ -498,7 +482,6 @@
 		if ((p->p_sflag & (PS_INMEM|PS_SWAPPING)) != PS_INMEM) {
 			mtx_unlock_spin(&sched_lock);
 			PROC_UNLOCK(p);
-			mtx_unlock(&vm_mtx);
 			continue;
 		}
 
@@ -506,7 +489,6 @@
 		default:
 			mtx_unlock_spin(&sched_lock);
 			PROC_UNLOCK(p);
-			mtx_unlock(&vm_mtx);
 			continue;
 
 		case SSLEEP:
@@ -517,7 +499,6 @@
 			if (PRI_IS_REALTIME(p->p_pri.pri_class)) {
 				mtx_unlock_spin(&sched_lock);
 				PROC_UNLOCK(p);
-				mtx_unlock(&vm_mtx);
 				continue;
 			}
 
@@ -530,7 +511,6 @@
 				(p->p_slptime < swap_idle_threshold1)) {
 				mtx_unlock_spin(&sched_lock);
 				PROC_UNLOCK(p);
-				mtx_unlock(&vm_mtx);
 				continue;
 			}
 
@@ -544,7 +524,6 @@
 				  (p->p_slptime < swap_idle_threshold2))) {
 				mtx_unlock_spin(&sched_lock);
 				PROC_UNLOCK(p);
-				mtx_unlock(&vm_mtx);
 				continue;
 			}
 			mtx_unlock_spin(&sched_lock);
@@ -559,7 +538,6 @@
 					NULL, curproc)) {
 				vmspace_free(vm);
 				PROC_UNLOCK(p);
-				mtx_unlock(&vm_mtx);
 				continue;
 			}
 			vm_map_unlock(&vm->vm_map);
@@ -574,12 +552,10 @@
 				swapout(p);
 				vmspace_free(vm);
 				didswap++;
-				mtx_unlock(&vm_mtx);
 				goto retry;
 			}
 			PROC_UNLOCK(p);
 			vmspace_free(vm);
-			mtx_unlock(&vm_mtx);
 		}
 	}
 	sx_sunlock(&allproc_lock);
@@ -587,7 +563,6 @@
 	 * If we swapped something out, and another process needed memory,
 	 * then wakeup the sched process.
 	 */
-	mtx_lock(&vm_mtx);
 	if (didswap)
 		wakeup(&proc0);
 }
Index: vm/vm_init.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_init.c,v
retrieving revision 1.27
diff -u -r1.27 vm_init.c
--- vm/vm_init.c	2001/05/22 05:35:45	1.27
+++ vm/vm_init.c	2001/07/04 02:54:17
@@ -97,20 +97,15 @@
  *	The start and end address of physical memory is passed in.
  */
 
-struct mtx vm_mtx;
-
 /* ARGSUSED*/
 static void
 vm_mem_init(dummy)
 	void *dummy;
 {
-
 	/*
 	 * Initializes resident memory structures. From here on, all physical
 	 * memory is accounted for, and we use only virtual addresses.
 	 */
-	mtx_init(&vm_mtx, "vm", MTX_DEF);
-	mtx_lock(&vm_mtx);
 	vm_set_page_size();
 	virtual_avail = vm_page_startup(avail_start, avail_end, virtual_avail);
 	
@@ -123,5 +118,4 @@
 	kmem_init(virtual_avail, virtual_end);
 	pmap_init(avail_start, avail_end);
 	vm_pager_init();
-	mtx_unlock(&vm_mtx);
 }
Index: vm/vm_kern.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_kern.c,v
retrieving revision 1.71
diff -u -r1.71 vm_kern.c
--- vm/vm_kern.c	2001/06/22 06:35:22	1.71
+++ vm/vm_kern.c	2001/07/04 02:54:17
@@ -104,17 +104,13 @@
 {
 	vm_offset_t addr;
 	int result;
-	int hadvmlock;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
+
 	size = round_page(size);
 	addr = vm_map_min(map);
 	result = vm_map_find(map, NULL, (vm_offset_t) 0,
 	    &addr, size, TRUE, VM_PROT_ALL, VM_PROT_ALL, 0);
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	if (result != KERN_SUCCESS) {
 		return (0);
 	}
@@ -135,17 +131,12 @@
 	vm_offset_t addr;
 	int result;
 
-	int hadvmlock;
+	GIANT_REQUIRED;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
 	size = round_page(size);
 	addr = vm_map_min(map);
 	result = vm_map_find(map, NULL, (vm_offset_t) 0,
 	    &addr, size, TRUE, VM_PROT_ALL, VM_PROT_ALL, MAP_NOFAULT);
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	if (result != KERN_SUCCESS) {
 		return (0);
 	}
@@ -164,11 +155,9 @@
 	vm_offset_t addr;
 	vm_offset_t offset;
 	vm_offset_t i;
-	int hadvmlock;
+
+	GIANT_REQUIRED;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
 	size = round_page(size);
 
 	/*
@@ -184,8 +173,6 @@
 	vm_map_lock(map);
 	if (vm_map_findspace(map, vm_map_min(map), size, &addr)) {
 		vm_map_unlock(map);
-		if (!hadvmlock)
-			mtx_unlock(&vm_mtx);
 		return (0);
 	}
 	offset = addr - VM_MIN_KERNEL_ADDRESS;
@@ -230,8 +217,6 @@
 
 	(void) vm_map_pageable(map, (vm_offset_t) addr, addr + size, FALSE);
 
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	return (addr);
 }
 
@@ -250,16 +235,9 @@
 	vm_offset_t addr;
 	vm_size_t size;
 {
-	int hadvmlock;
-
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 
 	(void) vm_map_remove(map, trunc_page(addr), round_page(addr + size));
-
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 }
 
 /*
@@ -282,11 +260,8 @@
 {
 	int ret;
 	vm_map_t result;
-	int hadvmlock;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 
 	size = round_page(size);
 
@@ -304,8 +279,6 @@
 		panic("kmem_suballoc: cannot create submap");
 	if (vm_map_submap(parent, *min, *max, result) != KERN_SUCCESS)
 		panic("kmem_suballoc: unable to change range to submap");
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	return (result);
 }
 
@@ -343,12 +316,9 @@
 	vm_map_entry_t entry;
 	vm_offset_t addr;
 	vm_page_t m;
-	int hadvmlock;
+
+	GIANT_REQUIRED;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
-		
 	size = round_page(size);
 	addr = vm_map_min(map);
 
@@ -444,13 +414,9 @@
 	}
 	vm_map_unlock(map);
 
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	return (addr);
 
 bad:	
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	return (0);
 }
 
@@ -469,11 +435,8 @@
 	vm_size_t size;
 {
 	vm_offset_t addr;
-	int hadvmlock;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 
 	size = round_page(size);
 
@@ -488,17 +451,13 @@
 		/* no space now; see if we can ever get space */
 		if (vm_map_max(map) - vm_map_min(map) < size) {
 			vm_map_unlock(map);
-			if (!hadvmlock)
-				mtx_unlock(&vm_mtx);
 			return (0);
 		}
 		vm_map_unlock(map);
-		msleep(map, &vm_mtx, PVM, "kmaw", 0);
+		tsleep(map, PVM, "kmaw", 0);
 	}
 	vm_map_insert(map, NULL, (vm_offset_t) 0, addr, addr + size, VM_PROT_ALL, VM_PROT_ALL, 0);
 	vm_map_unlock(map);
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	return (addr);
 }
 
@@ -514,17 +473,12 @@
 	vm_offset_t addr;
 	vm_size_t size;
 {
-	int hadvmlock;
+	GIANT_REQUIRED;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
 	vm_map_lock(map);
 	(void) vm_map_delete(map, trunc_page(addr), round_page(addr + size));
 	wakeup(map);
 	vm_map_unlock(map);
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 }
 
 /*
